#include <stdio.h>
#include <locale.h>
#include <stdlib.h>

struct Node
{
	int top1, top2;
	Node *next;
};
typedef Node *PNode;

void Add(PNode &Head, int x, int y)
{
	PNode NewNode=new Node;
	NewNode->top1=x;
	NewNode->top2=y;
	NewNode->next=NULL;

	PNode q=Head;
	if (Head==NULL)
	{
		NewNode->next=Head;
		Head=NewNode;
		return;
	}

	while (q->next) q=q->next;
	NewNode->next=q->next;
	q->next=NewNode;
	return;
}

void Delete(PNode &Head, PNode OldNode)
{
	PNode q=Head;
	if (Head==OldNode)
		Head=OldNode->next;
	else 
	{
		while (q && q->next != OldNode) q = q->next;
		if (q==NULL) return;
		q->next=OldNode->next;
	}
	delete OldNode;
}

void Menu()
{
	system("cls");
	printf("\n");
	printf("1.  \n");
	printf("2.   \n");
	printf("3.   \n");
	printf("4. \n");
}

void main()
{
	PNode Head=NULL, q;
	int n, x, i, j, y, c, err=0, err1, topcount, edgecount=0;
	setlocale(LC_ALL,"Russian");


	printf("\n\n");
	printf("  : ");
	if(scanf("%d",&n)==0) {printf("\n  !\n"); return;}
	topcount=n*(n-1)/2;
	Menu();
	printf("\n   = %d\n",topcount);

	while (1)
	{
		printf("\n> ");

		if(scanf("%d",&c)==0) {printf("\n  !\n"); return;}

		switch(c)
		{
		default: Menu(); printf("\n  4!\n"); break;

		case 1:
			Menu();

			printf("\n  %d \n",edgecount);
			printf("\n  1: ");
			if(scanf("%d", &x)==0) {printf("\n  !\n"); return;}
			if((x<1) || (x>n)) {printf("\n   1  %d!\n",n); break;}

			printf("\n  2: ");
			if(scanf("%d", &y)==0) {printf("\n  !\n"); return;}
			if((y<1) || (y>n)) {printf("\n   1  %d!\n",n); break;}

			if(x==y)
			{
				err=1;
				Add(Head, x, y);
				break;
			}

			if(edgecount==topcount)
			{
				printf("\n  !\n");
				break;
			}

			err1=0;
			q=Head;
			for(i=0;i<edgecount;i++)
			{
				if((q->top1==x) && (q->top2==y))
				{
					err1=1;
					printf("\n   !\n");
					break;
				}
			}

			if(err1==0)
			{
			Add(Head, x, y);
			edgecount++;
			}
			break;

		case 2: 
			{
				Menu();

				int **m=NULL;
				m=(int**)malloc(sizeof(int*)*n);
				for(i=0;i<n;i++)
					m[i]=(int*)malloc(sizeof(int)*n);
				for(i=0;i<n;i++)
					for(j=0;j<n;j++)
						m[i][j]=0;

				q=Head;
				i=0;
				j=0;
				while(q!=NULL)
				{
					m[q->top1-1][q->top2-1]=1;
					q=q->next;
				}

				for(i=0;i<n;i++)
					for(j=0;j<n;j++)
						if(m[j][i]==0)
							m[j][i]=m[i][j];
						else
							m[i][j]=m[j][i];

				printf("\n :\n\n");
				for(i=0;i<n;i++)
				{
					for(j=0;j<n;j++)
						printf("%-2d",m[i][j]);
					printf("\n");
				}

				for(i=0;i<n;i++)
					free(m[i]);
				free(m);
				break;
			}

		case 3: 
			{
				Menu();

				if(err==1){printf("\n       \n\n"); break;}

				int **m=NULL;
				m=(int**)malloc(sizeof(int*)*n);
				for(i=0;i<n;i++)
					m[i]=(int*)malloc(sizeof(int)*edgecount);
				
				for(i=0;i<n;i++)
					for(j=0;j<edgecount;j++)
						m[i][j]=0;

				q=Head;
				for(j=0;j<edgecount;j++)
				{
					m[q->top1-1][j]=1;
					m[q->top2-1][j]=1;
					q=q->next;
				}

				printf("\n :\n\n");
				for(i=0;i<n;i++)
				{
					for(j=0;j<edgecount;j++)
						printf("%-2d",m[i][j]);
					printf("\n");
				}

				for(i=0;i<n;i++)
					free(m[i]);
				free(m);
				break;
			}

		case 4: 
			while (Head!=NULL) Delete(Head, Head);
			printf("\n");
			return;
		}
	}
	return;
}